unit frmMainU;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, System.Contnrs, Vcl.StdCtrls, Vcl.Menus, Vcl.ComCtrls, Vcl.ExtCtrls,
  hyieutils, iexBitmaps, hyiedefs, iesettings, ieview, imageenview, ievect, spenginedll, spglobals, ieopensavedlg, iexRulers,
  iexColorPalette;

type
  TForm1 = class(TForm)
    PaintView1: TImageEnVect;
    PanelLeft: TPanel;
    StatusBar1: TStatusBar;
    PanelBottom: TPanel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    menuLoadImage: TMenuItem;
    menuSaveImageAs: TMenuItem;
    pageCommon: TPageControl;
    TabSheet1: TTabSheet;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    TabSheet2: TTabSheet;
    GroupBox3: TGroupBox;
    chkFiltersChalk: TCheckBox;
    chkFiltersBlur: TCheckBox;
    pageBrushes: TPageControl;
    TabSheet3: TTabSheet;
    GroupBox2: TGroupBox;
    rbtNeonLinear: TRadioButton;
    rbtNeonQuadratic: TRadioButton;
    rbtNeonTrigonometric: TRadioButton;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    TabSheet7: TTabSheet;
    TabSheet8: TTabSheet;
    rgpSolid: TRadioGroup;
    labSolidThick: TLabel;
    TabSheet9: TTabSheet;
    TabSheet10: TTabSheet;
    TabSheet11: TTabSheet;
    OpenImage: TOpenImageEnDialog;
    OpenStamp: TOpenImageEnDialog;
    GroupBox4: TGroupBox;
    chkBumpEnable: TCheckBox;
    chkBumpSoft: TCheckBox;
    Label25: TLabel;
    Label26: TLabel;
    chkBumpInvertThreshold: TCheckBox;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    popShape: TPopupMenu;
    shFree: TMenuItem;
    N1: TMenuItem;
    shLine: TMenuItem;
    N2: TMenuItem;
    shRectOut: TMenuItem;
    shRectFilled: TMenuItem;
    shRectFilled0: TMenuItem;
    N3: TMenuItem;
    shEllipseOut: TMenuItem;
    shEllipseFilled: TMenuItem;
    shEllipseFilled0: TMenuItem;
    TabSheet12: TTabSheet;
    GroupBox5: TGroupBox;
    chkJitterOn: TCheckBox;
    chkJitterConnected: TCheckBox;
    Label30: TLabel;
    Label31: TLabel;
    TabSheet13: TTabSheet;
    GroupBox6: TGroupBox;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    TextureView: TImageEnView;
    Label35: TLabel;
    TileView: TImageEnView;
    Label36: TLabel;
    chkColorAutoStepper: TCheckBox;
    OpenTexture: TOpenImageEnDialog;
    OpenTile: TOpenImageEnDialog;
    Label37: TLabel;
    btnTextureClear: TButton;
    btnTileClear: TButton;
    GroupBox7: TGroupBox;
    PolyTextureView: TImageEnView;
    btnPolyTextureClear: TButton;
    rbtPolyColor: TRadioButton;
    rbtPolyTexture: TRadioButton;
    chkPolyFillOver: TCheckBox;
    TabSheet14: TTabSheet;
    chkPolyCapacity: TCheckBox;
    Label41: TLabel;
    Label42: TLabel;
    SaveImage: TSaveImageEnDialog;
    Clear1: TButton;
    trackSize: TTrackBar;
    trackCapacity: TTrackBar;
    trackColorVary: TTrackBar;
    trackSizeVary: TTrackBar;
    trackCapVary: TTrackBar;
    trackStep: TTrackBar;
    trackBlurRadius: TTrackBar;
    trackBumpScale: TTrackBar;
    trackBumpThreshold: TTrackBar;
    trackBumpRoughness: TTrackBar;
    trackJitterRange: TTrackBar;
    trackJitterLoop: TTrackBar;
    trackPolyCapacity: TTrackBar;
    trackColorStepper: TTrackBar;
    trackNeonLinear: TTrackBar;
    trackNeonTrigonometric: TTrackBar;
    trackSolidThick: TTrackBar;
    editBumpY: TEdit;
    editBumpX: TEdit;
    UpDown1: TUpDown;
    UpDown2: TUpDown;
    cmbColorPoly: TColorBox;
    cmbColorPrimary: TColorBox;
    cmbColorSecondary: TColorBox;
    Undo1: TButton;
    Exit2: TButton;
    Fit1: TCheckBox;
    TrackZoom: TTrackBar;
    Zoom: TLabel;
    DisplayCursor1: TCheckBox;
    IEColorPalette1: TIEColorPalette;
    IEColorPalette2: TIEColorPalette;
    listColorScheme: TListBox;
    menuSaveImage: TMenuItem;
    HeaderControl1: THeaderControl;
    HeaderControl2: THeaderControl;
    N4: TMenuItem;
    Exit1: TMenuItem;
    GroupBox8: TGroupBox;
    trackShadowX: TTrackBar;
    cmbColorShadow: TColorBox;
    trackShadowCapacity: TTrackBar;
    trackShadowY: TTrackBar;
    trackShadowBlur: TTrackBar;
    chkShadowOn: TCheckBox;
    chkShadowBlur: TCheckBox;
    shpFor: TShape;
    shpBack: TShape;
    Label40: TLabel;
    Label39: TLabel;
    Label38: TLabel;
    Label24: TLabel;
    GroupBox9: TGroupBox;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    trackSprayDensity: TTrackBar;
    trackSprayGravity: TTrackBar;
    trackSprayIntVary: TTrackBar;
    trackSprayThick: TTrackBar;
    GroupBox10: TGroupBox;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    trackStarDensity: TTrackBar;
    trackStarIntVary: TTrackBar;
    trackStarThick: TTrackBar;
    GroupBox11: TGroupBox;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    trackHairThick: TTrackBar;
    trackHairIntVary: TTrackBar;
    trackHairDensity: TTrackBar;
    GroupBox12: TGroupBox;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    trackMeshDensity: TTrackBar;
    trackMeshIntVary: TTrackBar;
    trackMeshThick: TTrackBar;
    GroupBox13: TGroupBox;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    trackParallelAngle: TTrackBar;
    trackParallelSpacing: TTrackBar;
    trackParallelIntVary: TTrackBar;
    trackParallelThick: TTrackBar;
    GroupBox14: TGroupBox;
    labStampBrush: TLabel;
    StampView: TImageEnView;
    LabelSize1: TLabel;
    LabelOpacity1: TLabel;
    LabelColorVary1: TLabel;
    LabelSizeVary1: TLabel;
    LabelCapVary1: TLabel;
    LabelStep1: TLabel;
    Label47: TLabel;
    LabelBlurRadius1: TLabel;
    LabelBumpScale1: TLabel;
    LabelBumpThreshold1: TLabel;
    LabelBumpRoughness1: TLabel;
    LabelJitterRange1: TLabel;
    LabelJitterLoop1: TLabel;
    LabelPolyCapacity1: TLabel;
    LabelColorStepper1: TLabel;
    LabelNeonLinear1: TLabel;
    LabelNeonTrigonometric1: TLabel;
    LabelShadowX1: TLabel;
    LabelShadowY1: TLabel;
    LabelShadowBlur1: TLabel;
    LabelShadowCapacity1: TLabel;
    LabelSolidThick1: TLabel;
    LabelSprayThick1: TLabel;
    LabelSprayIntVary1: TLabel;
    LabelSprayGravity1: TLabel;
    LabelSprayDensity1: TLabel;
    LabelStarThick1: TLabel;
    LabelStarIntVary1: TLabel;
    LabelStarDensity1: TLabel;
    LabelHairThick1: TLabel;
    LabelHairIntVary1: TLabel;
    LabelHairDensity1: TLabel;
    LabelMeshThick1: TLabel;
    LabelMeshIntVary1: TLabel;
    LabelMeshDensity1: TLabel;
    LabelParallelThick1: TLabel;
    LabelParallelIntVary1: TLabel;
    LabelParallelSpacing1: TLabel;
    LabelParallelAngle1: TLabel;
    chkSolidFilled: TCheckBox;
    BalloonHint1: TBalloonHint;
    procedure PaintView1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure PaintView1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure PaintView1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure basicChange(Sender: TObject);
    procedure brushNeonChange(Sender: TObject);
    procedure pageBrushesChange(Sender: TObject);
    procedure filtersChange(Sender: TObject);
    procedure rgpSolidClick(Sender: TObject);
    procedure trackSolidChange(Sender: TObject);
    procedure trackSprayChange(Sender: TObject);
    procedure trackStarChange(Sender: TObject);
    procedure trackHairChange(Sender: TObject);
    procedure trackMeshChange(Sender: TObject);
    procedure trackParallelChange(Sender: TObject);
    procedure StampViewDblClick(Sender: TObject);
    procedure bumpChange(Sender: TObject);
    procedure popShapeClick(Sender: TObject);
    procedure jitterChange(Sender: TObject);
    procedure colorChange(Sender: TObject);
    procedure TextureViewDblClick(Sender: TObject);
    procedure TileViewDblClick(Sender: TObject);
    procedure listColorSchemeClick(Sender: TObject);
    procedure btnTextureClearClick(Sender: TObject);
    procedure btnTileClearClick(Sender: TObject);
    procedure menuLoadImageClick(Sender: TObject);
    procedure PolyTextureViewDblClick(Sender: TObject);
    procedure btnPolyTextureClearClick(Sender: TObject);
    procedure polyChanged(Sender: TObject);
    procedure shadowChange(Sender: TObject);
    procedure menuSaveImageAsClick(Sender: TObject);
    procedure trackSizeChange(Sender: TObject);
    procedure trackCapacityChange(Sender: TObject);
    procedure trackColorVaryChange(Sender: TObject);
    procedure trackSizeVaryChange(Sender: TObject);
    procedure trackCapVaryChange(Sender: TObject);
    procedure trackStepChange(Sender: TObject);
    procedure trackJitterRangeChange(Sender: TObject);
    procedure trackJitterLoopChange(Sender: TObject);
    procedure trackStarThickChange(Sender: TObject);
    procedure trackStarIntVaryChange(Sender: TObject);
    procedure trackStarDensityChange(Sender: TObject);
    procedure trackHairThickChange(Sender: TObject);
    procedure trackHairIntVaryChange(Sender: TObject);
    procedure trackHairDensityChange(Sender: TObject);
    procedure trackMeshThickChange(Sender: TObject);
    procedure trackMeshIntVaryChange(Sender: TObject);
    procedure trackMeshDensityChange(Sender: TObject);
    procedure trackParallelThickChange(Sender: TObject);
    procedure trackParallelIntVaryChange(Sender: TObject);
    procedure trackParallelSpacingChange(Sender: TObject);
    procedure trackParallelAngleChange(Sender: TObject);
    procedure trackColorStepperChange(Sender: TObject);
    procedure trackShadowXChange(Sender: TObject);
    procedure trackShadowYChange(Sender: TObject);
    procedure trackShadowBlurChange(Sender: TObject);
    procedure trackShadowCapacityChange(Sender: TObject);
    procedure cmbColorShadowChange(Sender: TObject);
    procedure trackSolidThickChange(Sender: TObject);
    procedure trackBlurRadiusChange(Sender: TObject);
    procedure trackBumpScaleChange(Sender: TObject);
    procedure trackBumpThresholdChange(Sender: TObject);
    procedure trackBumpRoughnessChange(Sender: TObject);
    procedure trackPolyCapacityChange(Sender: TObject);
    procedure trackSprayThickChange(Sender: TObject);
    procedure trackSprayIntVaryChange(Sender: TObject);
    procedure trackSprayGravityChange(Sender: TObject);
    procedure trackSprayDensityChange(Sender: TObject);
    procedure trackNeonLinearChange(Sender: TObject);
    procedure trackNeonTrigonometricChange(Sender: TObject);
    procedure Undo1Click(Sender: TObject);
    procedure Exit2Click(Sender: TObject);
    procedure Clear1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Fit1Click(Sender: TObject);
    procedure TrackZoomChange(Sender: TObject);
    procedure PaintView1ViewChange(Sender: TObject; Change: Integer);
    procedure PaintView1DrawBackBuffer(Sender: TObject);
    procedure DisplayCursor1Click(Sender: TObject);
    procedure IEColorPalette1SelectedColorChange(Sender: TObject);
    procedure IEColorPalette2SelectedColorChange(Sender: TObject);
    procedure DisplayCursor1MouseLeave(Sender: TObject);
    procedure DisplayCursor1MouseEnter(Sender: TObject);
    procedure menuSaveImageClick(Sender: TObject);
    procedure PaintView1MouseLeave(Sender: TObject);
    procedure PaintView1MouseEnter(Sender: TObject);
    procedure cmbColorPrimarySelect(Sender: TObject);
    procedure cmbColorSecondarySelect(Sender: TObject);
    procedure pageCommonChange(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure chkSolidFilledClick(Sender: TObject);
  private
    { Private declarations }
    ABX: Integer;
    ABY: Integer;
    procedure setBrushCommonParams();
    procedure setColorParams();
    procedure setNeonSpecific();
    procedure setSolidSpecific();
    procedure setSpraySpecific();
    procedure setStarSpecific();
    procedure setHairSpecific();
    procedure setMeshSpecific();
    procedure setParallelSpecific();
    procedure setStampSpecific();
    procedure loadTexture(filename: UnicodeString);
    procedure loadTile(filename: UnicodeString);
    procedure loadPolyTexture(filename: UnicodeString);
    procedure loadStamp(filename: UnicodeString);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  ARenderData: Tpx_RenderData;
  ABrushCommonParams: Tpx_BrushCommonParams;
  ANeonSpecific: PTpx_BrushNeonSpecific;
  ASolidSpecific: PTpx_BrushSolidSpecific;
  ASpraySpecific: PTpx_BrushSpraySpecific;
  AStarSpecific: PTpx_BrushStarSpecific;
  AHairSpecific: PTpx_BrushHairSpecific;
  AMeshSpecific: PTpx_BrushMeshSpecific;
  AParallelSpecific: PTpx_BrushParallelSpecific;
  AColorScheme: Integer;
  AStampName, ATextureName, ATileName, APolyTextureName: UnicodeString;
  AShapeType: TspeShapeType;
  AMouseData: Tpx_MouseData;
  AMouseDown: Boolean;
  Ahobj: Integer;
  AUndoMap: TIEBitmap;
  NameVer: UnicodeString;

implementation

{$R *.dfm}

uses imageenproc;

function AddThousandSeparator(const AString: string; const AChar: char): string;
{ Add a specified thousand separator in the correct location in a string. }
var
  i: Integer; { Loop through separator position }
begin
  Result := AString;
  i := Length(AString) - 2;
  while i > 1 do
  begin
    Insert(AChar, Result, i);
    i := i - 3;
  end;
end;

function AddDefThousandSeparator(const AString: string): string;
{ Add the local default thousand separator in the correct location in a string. }
begin
  Result := AddThousandSeparator(AString, System.SysUtils.FormatSettings.ThousandSeparator);
end;

function IntegerToString(const i: Int64): string;
{ Add the local default thousand separator in the correct location in a number and return a string. }
begin
  Result := AddThousandSeparator(IntToStr(i), System.SysUtils.FormatSettings.ThousandSeparator);
end;

procedure TForm1.setBrushCommonParams();
begin
  ABrushCommonParams.Size := trackSize.Position;
  ABrushCommonParams.Capacity := trackCapacity.Position;
  ABrushCommonParams.ColorVary := trackColorVary.Position;
  ABrushCommonParams.SizeVary := trackSizeVary.Position;
  ABrushCommonParams.CapVary := trackCapVary.Position;
  ABrushCommonParams.Step := trackStep.Position;
  // filters
  ABrushCommonParams.ChalkOn := chkFiltersChalk.Checked;
  ABrushCommonParams.BlurOn := chkFiltersBlur.Checked;
  ABrushCommonParams.BlurValue := trackBlurRadius.Position;
  // bumping
  ABrushCommonParams.BumpOn := chkBumpEnable.Checked;
  ABrushCommonParams.BumpSoft := chkBumpSoft.Checked;
  ABrushCommonParams.BumpScaleValue := trackBumpScale.Position * 1.0 / 100.0;
  ABrushCommonParams.BumpThresholdValue := trackBumpThreshold.Position;
  ABrushCommonParams.BumpInvertThreshold := chkBumpInvertThreshold.Checked;
  ABrushCommonParams.BumpRoughnessValue := trackBumpRoughness.Position;
  ABrushCommonParams.BumpXoffsetValue := StrToInt(editBumpX.Text);
  ABrushCommonParams.BumpYoffsetValue := StrToInt(editBumpY.Text);
  // jitter
  ABrushCommonParams.JitterOn := chkJitterOn.Checked;
  ABrushCommonParams.JitterConnectedOn := chkJitterConnected.Checked;
  ABrushCommonParams.JitterRangeValue := trackJitterRange.Position;
  ABrushCommonParams.JitterLoopValue := trackJitterLoop.Position;
  // poly (closed shapes filling)
  ABrushCommonParams.PolyFillOver := chkPolyFillOver.Checked;
  ABrushCommonParams.PolyColorIndex := Integer(rbtPolyTexture.Checked) * 1;
  speSetBrushCommon(ABrushCommonParams);
end;

procedure TForm1.setColorParams();
var
  iColor1, iColor2, iColor3: Cardinal;
begin
  // colors
  iColor1 := Cardinal(cmbColorPrimary.Selected);
  iColor2 := Cardinal(cmbColorSecondary.Selected);
  iColor3 := Cardinal(cmbColorPoly.Selected);
  speSetStandardColors(iColor1, iColor2, iColor3);
  if not ATextureName.IsEmpty then
    loadTexture(ATextureName);
  if not ATileName.IsEmpty then
    loadTile(ATileName);
  if not APolyTextureName.IsEmpty then
    loadPolyTexture(APolyTextureName);
end;

procedure TForm1.setNeonSpecific();
begin
  ANeonSpecific.FalloffIndex := Integer(rbtNeonQuadratic.Checked) * 1 + Integer(rbtNeonTrigonometric.Checked) * 2;
  ANeonSpecific.LinearValue := trackNeonLinear.Position;
  ANeonSpecific.TrigonometricValue := trackNeonTrigonometric.Position;
end;

// ---------------------------------------------------------------------------
procedure TForm1.setSolidSpecific();
begin
  ASolidSpecific.Shape := rgpSolid.ItemIndex;
  ASolidSpecific.Filled := chkSolidFilled.Checked;
  ASolidSpecific.Thickness := trackSolidThick.Position;
  //ASolidSpecific.Angle := 0;
  ASolidSpecific.RandomAngle := True;
end;

procedure TForm1.setSpraySpecific();
begin
  ASpraySpecific.Thickness := trackSprayThick.Position;
  ASpraySpecific.IntVary := trackSprayIntVary.Position;
  ASpraySpecific.Gravity := trackSprayGravity.Position;
  ASpraySpecific.Density := trackSprayDensity.Position;
end;

procedure TForm1.setStarSpecific();
begin
  AStarSpecific.Thickness := trackStarThick.Position;
  AStarSpecific.IntVary := trackStarIntVary.Position;
  AStarSpecific.Density := trackStarDensity.Position;
end;

procedure TForm1.setHairSpecific();
begin
  AHairSpecific.Thickness := trackHairThick.Position;
  AHairSpecific.IntVary := trackHairIntVary.Position;
  AHairSpecific.Density := trackHairDensity.Position;
end;

procedure TForm1.setMeshSpecific();
begin
  AMeshSpecific.Thickness := trackMeshThick.Position;
  AMeshSpecific.IntVary := trackMeshIntVary.Position;
  AMeshSpecific.Density := trackMeshDensity.Position;
end;

procedure TForm1.setParallelSpecific();
begin
  AParallelSpecific.Thickness := trackParallelThick.Position;
  AParallelSpecific.IntVary := trackParallelIntVary.Position;
  AParallelSpecific.Spacing := trackParallelSpacing.Position;
  AParallelSpecific.Angle := trackParallelAngle.Position;
end;

procedure TForm1.setStampSpecific();
begin
  if not AStampName.IsEmpty then
    loadStamp(AStampName);
end;

procedure TForm1.loadTexture(filename: UnicodeString);
var
  ieMap: TIEBitmap;
  iWidth, iHeight: Integer;
begin
  TextureView.IO.LoadFromFile(filename);
  ieMap := TextureView.IEBitmap;
  if (ieMap.PixelFormat <> ie24RGB) then
  begin
    TextureView.Proc.ConvertTo24Bit();
    ieMap := TextureView.IEBitmap;
  end;
  iWidth := ieMap.Width;
  iHeight := ieMap.Height;
  speSetTexture(ieMap.ScanLine[iHeight - 1], iWidth, iHeight, 4);
end;

procedure TForm1.loadPolyTexture(filename: UnicodeString);
var
  ieMap: TIEBitmap;
  iWidth, iHeight: Integer;
begin
  PolyTextureView.IO.LoadFromFile(filename);
  ieMap := PolyTextureView.IEBitmap;
  if (ieMap.PixelFormat <> ie24RGB) then
  begin
    TextureView.Proc.ConvertTo24Bit();
    ieMap := PolyTextureView.IEBitmap;
  end;
  iWidth := ieMap.Width;
  iHeight := ieMap.Height;
  speSetPolyTexture(ieMap.ScanLine[iHeight - 1], iWidth, iHeight, 4);
end;

procedure TForm1.loadTile(filename: UnicodeString);
var
  ieMap: TIEBitmap;
  iWidth, iHeight: Integer;
begin
  TileView.IO.LoadFromFile(filename);
  ieMap := TileView.IEBitmap;
  if (ieMap.PixelFormat <> ie8g) then
  begin
    TileView.Proc.ConvertToGray();
    TileView.IEBitmap.PixelFormat := ie8g;
    ieMap := TileView.IEBitmap;
  end;
  iWidth := ieMap.Width;
  iHeight := ieMap.Height;
  speSetBackgroundTile(ieMap.ScanLine[iHeight - 1], iWidth, iHeight, 4);
end;

procedure TForm1.menuLoadImageClick(Sender: TObject);
var
  iWidth, iHeight: Integer;
  iAlphaScanline: Pointer;
begin
  if OpenImage.Execute then
  begin
    PaintView1.IO.LoadFromFile(OpenImage.filename);
    if PaintView1.IEBitmap.PixelFormat <> ie24RGB then
      PaintView1.Proc.ConvertTo24Bit();
    iHeight := PaintView1.IEBitmap.Height;
    iWidth := PaintView1.IEBitmap.Width;
    AUndoMap.Assign(PaintView1.IEBitmap);
    iAlphaScanline := nil;
    if PaintView1.HasAlphaChannel then
      iAlphaScanline := PaintView1.AlphaChannel.ScanLine[iHeight - 1];
    speSetSurface(PaintView1.IEBitmap.ScanLine[iHeight - 1], iAlphaScanline, iWidth, iHeight, 4);
    speSetShape(AShapeType); // set shape
    pageBrushesChange(self); // set brush stuff
    speSetRender(px_rndDraw); // set render engine
    setColorParams();
    PaintView1.Update;
    Caption := NameVer + OpenImage.filename;
    StatusBar1.Panels[0].Text := ExtractFileDir(OpenImage.filename);
    StatusBar1.Panels[1].Text := ExtractFileName(OpenImage.filename);
  end;
end;

procedure TForm1.menuSaveImageAsClick(Sender: TObject);
begin
  if SaveImage.Execute then
  begin
    PaintView1.IO.SaveToFile(SaveImage.filename);
    Caption := NameVer + SaveImage.filename;
    StatusBar1.Panels[0].Text := ExtractFileDir(SaveImage.filename);
    StatusBar1.Panels[1].Text := ExtractFileName(SaveImage.filename);
  end;
end;

procedure TForm1.menuSaveImageClick(Sender: TObject);
begin
  if FileExists(OpenImage.filename) then
    PaintView1.IO.SaveToFile(OpenImage.filename);
end;

procedure TForm1.loadStamp(filename: UnicodeString);
var
  ieMap, aMap: TIEBitmap;
  iWidth, iHeight: Integer;
begin
  StampView.IO.LoadFromFile(OpenStamp.filename);
  ieMap := StampView.IEBitmap;
  if (ieMap.HasAlphaChannel) then // take alpha channel instead of image
  begin
    aMap := ieMap.AlphaChannel;
    ieMap := aMap;
  end
  else if (ieMap.PixelFormat <> ie8g) then
  begin
    StampView.Proc.ConvertToGray();
    StampView.IEBitmap.PixelFormat := ie8g;
    ieMap := StampView.IEBitmap;
  end;
  iWidth := ieMap.Width;
  iHeight := ieMap.Height;
  if (speSetStamp(ieMap.ScanLine[iHeight - 1], iWidth, iHeight, 4)) then
    labStampBrush.Caption := 'Original stamp size: ' + IntToStr(iWidth) + ' x ' + IntToStr(iHeight)
  else
    labStampBrush.Caption := 'Stamp brush empty!';
end;

procedure TForm1.popShapeClick(Sender: TObject);
var
  temp_item: TMenuItem;
begin
  temp_item := TMenuItem(Sender);
  temp_item.Checked := True;
  case temp_item.Tag of
    0:
      AShapeType := px_shpFreeHand;
    1:
      AShapeType := px_shpLine;
    2:
      AShapeType := px_shpRectangle;
    3:
      AShapeType := px_shpRectangleFilled;
    4:
      AShapeType := px_shpRectangleFilledNB;
    5:
      AShapeType := px_shpEllipse;
    6:
      AShapeType := px_shpEllipseFilled;
    7:
      AShapeType := px_shpEllipseFilledNB;
  end;
  speSetShape(AShapeType);
end;

procedure TForm1.StampViewDblClick(Sender: TObject);
begin
  OpenStamp.InitialDir := ExtractFilePath(Application.ExeName) + 'bstamps';
  if (OpenStamp.Execute()) then
  begin
    loadStamp(OpenStamp.filename);
    AStampName := OpenStamp.filename;
  end;
end;

procedure TForm1.TextureViewDblClick(Sender: TObject);
begin
  OpenTexture.InitialDir := ExtractFilePath(Application.ExeName) + 'textures';
  if (OpenTexture.Execute()) then
  begin
    loadTexture(OpenTexture.filename);
    ATextureName := OpenTexture.filename;
  end;
end;

procedure TForm1.TileViewDblClick(Sender: TObject);
begin
  OpenTile.InitialDir := ExtractFilePath(Application.ExeName) + 'tiles';
  if (OpenTile.Execute()) then
  begin
    loadTile(OpenTile.filename);
    ATileName := OpenTile.filename;
  end;
end;

// ---------------------------------------------------------------------------
procedure TForm1.TrackZoomChange(Sender: TObject);
begin
  TrackZoom.Hint := 'Zoom: ' + IntToStr(Round(PaintView1.Zoom)) + '%';
  PaintView1.Zoom := TrackZoom.Position;
  Zoom.Caption := 'Zoom: ' + IntToStr(Round(PaintView1.Zoom)) + '%';
end;

procedure TForm1.polyChanged(Sender: TObject);
begin
  setBrushCommonParams();
end;

procedure TForm1.PolyTextureViewDblClick(Sender: TObject);
begin
  if (OpenTexture.Execute()) then
  begin
    loadPolyTexture(OpenTexture.filename);
    APolyTextureName := OpenTexture.filename;
  end;
end;

procedure TForm1.basicChange(Sender: TObject);
begin
  setBrushCommonParams();
end;

procedure TForm1.trackBlurRadiusChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackBlurRadius.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackBlurRadius.Left - iSpace;
    { Set trackbar position }
    with trackBlurRadius do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
    LabelBlurRadius1.Caption := IntToStr(trackBlurRadius.Position);
  end;
end;

procedure TForm1.trackBumpRoughnessChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackBumpRoughness.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackBumpRoughness.Left - iSpace;
    { Set trackbar position }
    with trackBumpRoughness do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
    LabelBumpRoughness1.Caption := IntToStr(trackBumpRoughness.Position);
  end;
end;

procedure TForm1.trackBumpScaleChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackBumpScale.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackBumpScale.Left - iSpace;
    { Set trackbar position }
    with trackBumpScale do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
    LabelBumpScale1.Caption := IntToStr(trackBumpScale.Position);
  end;
end;

procedure TForm1.trackBumpThresholdChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackBumpThreshold.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackBumpThreshold.Left - iSpace;
    { Set trackbar position }
    with trackBumpThreshold do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
    LabelBumpThreshold1.Caption := IntToStr(trackBumpThreshold.Position);
  end;
end;

procedure TForm1.trackCapacityChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackCapacity.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackCapacity.Left - iSpace;
    { Set trackbar position }
    with trackCapacity do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
  end;
  setBrushCommonParams;
  LabelOpacity1.Caption := IntToStr(trackCapacity.Position) + '%';
end;

procedure TForm1.trackCapVaryChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackCapVary.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackCapVary.Left - iSpace;
    { Set trackbar position }
    with trackCapVary do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
  end;
  setBrushCommonParams;
  LabelCapVary1.Caption := IntToStr(trackCapVary.Position);
end;

procedure TForm1.trackColorStepperChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackColorStepper.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackColorStepper.Left - iSpace;
    { Set trackbar position }
    with trackColorStepper do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
    LabelColorStepper1.Caption := IntToStr(trackColorStepper.Position);
  end;
  setColorParams;
end;

procedure TForm1.trackColorVaryChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackColorVary.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackColorVary.Left - iSpace;
    { Set trackbar position }
    with trackColorVary do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
  end;
  setBrushCommonParams;
  LabelColorVary1.Caption := IntToStr(trackColorVary.Position);
end;

procedure TForm1.trackHairChange(Sender: TObject);
begin
  setHairSpecific();
end;

procedure TForm1.trackHairDensityChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackHairDensity.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackHairDensity.Left - iSpace;
    { Set trackbar position }
    with trackHairDensity do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
    LabelHairDensity1.Caption := IntToStr(trackHairDensity.Position);
  end;
  setHairSpecific;
end;

procedure TForm1.trackHairIntVaryChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackHairIntVary.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackHairIntVary.Left - iSpace;
    { Set trackbar position }
    with trackHairIntVary do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
    LabelHairIntVary1.Caption := IntToStr(trackHairIntVary.Position);
  end;
  setHairSpecific;
end;

procedure TForm1.trackHairThickChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackHairThick.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackHairThick.Left - iSpace;
    { Set trackbar position }
    with trackHairThick do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
    LabelHairThick1.Caption := IntToStr(trackHairThick.Position);
  end;
  setHairSpecific;
end;

procedure TForm1.trackJitterLoopChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackJitterLoop.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackJitterLoop.Left - iSpace;
    { Set trackbar position }
    with trackJitterLoop do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
  end;
  setBrushCommonParams;
  LabelJitterLoop1.Caption := IntToStr(trackJitterLoop.Position);
end;

procedure TForm1.trackJitterRangeChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackJitterRange.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackJitterRange.Left - iSpace;
    { Set trackbar position }
    with trackJitterRange do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
  end;
  setBrushCommonParams;
  LabelJitterRange1.Caption := IntToStr(trackJitterRange.Position);
end;

procedure TForm1.trackMeshChange(Sender: TObject);
begin
  setMeshSpecific();
end;

procedure TForm1.trackMeshDensityChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackMeshDensity.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackMeshDensity.Left - iSpace;
    { Set trackbar position }
    with trackMeshDensity do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
    LabelMeshDensity1.Caption := IntToStr(trackMeshDensity.Position);
  end;
  setMeshSpecific;
end;

procedure TForm1.trackMeshIntVaryChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackMeshIntVary.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackMeshIntVary.Left - iSpace;
    { Set trackbar position }
    with trackMeshIntVary do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
    LabelMeshIntVary1.Caption := IntToStr(trackMeshIntVary.Position);
  end;
  setMeshSpecific;
end;

procedure TForm1.trackMeshThickChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackMeshThick.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackMeshThick.Left - iSpace;
    { Set trackbar position }
    with trackMeshThick do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
    LabelMeshThick1.Caption := IntToStr(trackMeshThick.Position);
  end;
  setMeshSpecific;
end;

procedure TForm1.trackNeonLinearChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackNeonLinear.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackNeonLinear.Left - iSpace;
    { Set trackbar position }
    with trackNeonLinear do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
    LabelNeonLinear1.Caption := IntToStr(trackNeonLinear.Position);
  end;
  setNeonSpecific;
end;

procedure TForm1.trackNeonTrigonometricChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackNeonTrigonometric.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackNeonTrigonometric.Left - iSpace;
    { Set trackbar position }
    with trackNeonTrigonometric do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
    LabelNeonTrigonometric1.Caption := IntToStr(trackNeonTrigonometric.Position);
  end;
  setNeonSpecific;
end;

procedure TForm1.trackParallelAngleChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackParallelAngle.MouseInClient then
  begin
    { Set position to mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackParallelAngle.Left - iSpace;
    { Set trackbar position }
    with trackParallelAngle do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
    LabelParallelAngle1.Caption := IntToStr(trackParallelAngle.Position);
  end;
  setParallelSpecific;
end;

procedure TForm1.trackParallelChange(Sender: TObject);
begin
  setParallelSpecific();
end;

procedure TForm1.trackParallelIntVaryChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackParallelIntVary.MouseInClient then
  begin
    { Set position to mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackParallelIntVary.Left - iSpace;
    { Set trackbar position }
    with trackParallelIntVary do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
    LabelParallelIntVary1.Caption := IntToStr(trackParallelIntVary.Position);
  end;
  setParallelSpecific;
end;

procedure TForm1.trackParallelSpacingChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackParallelSpacing.MouseInClient then
  begin
    { Set position to mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackParallelSpacing.Left - iSpace;
    { Set trackbar position }
    with trackParallelSpacing do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
    LabelParallelSpacing1.Caption := IntToStr(trackParallelSpacing.Position);
  end;
  setParallelSpecific;
end;

procedure TForm1.trackParallelThickChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackParallelThick.MouseInClient then
  begin
    { Set position to mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackParallelThick.Left - iSpace;
    { Set trackbar position }
    with trackParallelThick do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
    LabelParallelThick1.Caption := IntToStr(trackParallelThick.Position);
  end;
  setParallelSpecific;
end;

procedure TForm1.trackPolyCapacityChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackPolyCapacity.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackPolyCapacity.Left - iSpace;
    { Set trackbar position }
    with trackPolyCapacity do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
    LabelPolyCapacity1.Caption := IntToStr(trackPolyCapacity.Position);
  end;
end;

procedure TForm1.trackShadowBlurChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackShadowBlur.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackShadowBlur.Left - iSpace;
    { Set trackbar position }
    with trackShadowBlur do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
    LabelShadowBlur1.Caption := IntToStr(trackShadowBlur.Position);
  end;
  shadowChange(Sender);
end;

procedure TForm1.trackShadowCapacityChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackShadowCapacity.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackShadowCapacity.Left - iSpace;
    { Set trackbar position }
    with trackShadowCapacity do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
    LabelShadowCapacity1.Caption := IntToStr(trackShadowCapacity.Position);
  end;
  shadowChange(Sender);
end;

procedure TForm1.trackShadowXChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackShadowX.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackShadowX.Left - iSpace;
    { Set trackbar position }
    with trackShadowX do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
    LabelShadowX1.Caption := IntToStr(trackShadowX.Position);
  end;
  shadowChange(Sender);
end;

procedure TForm1.trackShadowYChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackShadowY.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackShadowY.Left - iSpace;
    { Set trackbar position }
    with trackShadowY do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
    LabelShadowY1.Caption := IntToStr(trackShadowY.Position);
  end;
  shadowChange(Sender);
end;

procedure TForm1.trackSizeChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  { This code was found at stackoverflow to position a trackbar position to the clicked mouse position which produces
    a result similar to the Developers Express cxTrackbar with the properties.thumbstep := cxtsJump;
    This does not work for all trackbars however. }
  if trackSize.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackSize.Left - iSpace;
    { Set trackbar position }
    with trackSize do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
  end;
  setBrushCommonParams;
  LabelSize1.Caption := IntToStr(trackSize.Position);
end;

procedure TForm1.trackSizeVaryChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackSizeVary.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackSizeVary.Left - iSpace;
    { Set trackbar position }
    with trackSizeVary do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
  end;
  setBrushCommonParams;
  LabelSizeVary1.Caption := IntToStr(trackSizeVary.Position);
end;

procedure TForm1.trackSolidChange(Sender: TObject);
begin
  setSolidSpecific();
end;

procedure TForm1.trackSolidThickChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackSolidThick.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackSolidThick.Left - iSpace;
    { Set trackbar position }
    with trackSolidThick do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
    LabelSolidThick1.Caption := IntToStr(trackSolidThick.Position);
  end;
  setSolidSpecific();
end;

procedure TForm1.brushNeonChange(Sender: TObject);
begin
  setNeonSpecific();
end;

procedure TForm1.btnTextureClearClick(Sender: TObject);
begin
  TextureView.Clear;
  ATextureName := '';
  speDeleteTexture;
end;

procedure TForm1.btnTileClearClick(Sender: TObject);
begin
  TileView.Clear;
  ATileName := '';
  speDeleteBackgroundTile;
end;

procedure TForm1.Clear1Click(Sender: TObject);
var
  i: Integer;
  iWidth, iHeight: Integer;
  iAlphaScanline: Pointer;
begin
  for i := 0 to PaintView1.Proc.UndoCount - 1 do
  begin
    PaintView1.Proc.Undo();
    PaintView1.Proc.ClearUndo;
    PaintView1.Update;
    AUndoMap.Assign(PaintView1.IEBitmap);
    iHeight := PaintView1.IEBitmap.Height;
    iWidth := PaintView1.IEBitmap.Width;
    AUndoMap.Assign(PaintView1.IEBitmap);
    iAlphaScanline := nil;
    if PaintView1.HasAlphaChannel then
      iAlphaScanline := PaintView1.AlphaChannel.ScanLine[iHeight - 1];
    speSetSurface(PaintView1.IEBitmap.ScanLine[iHeight - 1], iAlphaScanline, iWidth, iHeight, 4);
  end;
  speSetShape(AShapeType); // set shape
  pageBrushesChange(self); // set brush stuff
  speSetRender(px_rndDraw); // set render engine
  setColorParams();
  speSetColorScheme(AColorScheme);
  Caption := NameVer;
  Clear1.Enabled := PaintView1.Proc.CanUndo;
  Undo1.Enabled := PaintView1.Proc.CanUndo;
  StatusBar1.Panels[0].Text := '';
  StatusBar1.Panels[1].Text := '';
  StatusBar1.Panels[5].Text := 'Undo: ' + IntToStr(PaintView1.Proc.UndoCount);
end;

procedure TForm1.btnPolyTextureClearClick(Sender: TObject);
begin
  PolyTextureView.Clear;
  APolyTextureName := '';
  speDeletePolyTexture;
end;

procedure TForm1.trackSprayChange(Sender: TObject);
begin
  setSpraySpecific();
end;

procedure TForm1.trackSprayDensityChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackSprayDensity.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackSprayDensity.Left - iSpace;
    { Set trackbar position }
    with trackSprayDensity do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
    LabelSprayDensity1.Caption := IntToStr(trackSprayDensity.Position);
  end;
end;

procedure TForm1.trackSprayGravityChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackSprayGravity.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackSprayGravity.Left - iSpace;
    { Set trackbar position }
    with trackSprayGravity do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
    LabelSprayGravity1.Caption := IntToStr(trackSprayGravity.Position);
  end;
end;

procedure TForm1.trackSprayIntVaryChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackSprayIntVary.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackSprayIntVary.Left - iSpace;
    { Set trackbar position }
    with trackSprayIntVary do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
    LabelSprayIntVary1.Caption := IntToStr(trackSprayintVary.Position);
  end;
end;

procedure TForm1.trackSprayThickChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackSprayThick.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackSprayThick.Left - iSpace;
    { Set trackbar position }
    with trackSprayThick do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
    LabelSprayThick1.Caption := IntToStr(trackSprayThick.Position);
  end;
end;

procedure TForm1.trackStarChange(Sender: TObject);
begin
  setStarSpecific();
end;

procedure TForm1.trackStarDensityChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackStarDensity.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackStarDensity.Left - iSpace;
    { Set trackbar position }
    with trackStarDensity do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
    LabelStarDensity1.Caption := IntToStr(trackStarDensity.Position);
  end;
  setStarSpecific;
end;

procedure TForm1.trackStarIntVaryChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackStarIntVary.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackStarIntVary.Left - iSpace;
    { Set trackbar position }
    with trackStarIntVary do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
    LabelStarIntVary1.Caption := IntToStr(trackStarIntVary.Position);
  end;
  setStarSpecific;
end;

procedure TForm1.trackStarThickChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackStarThick.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackStarThick.Left - iSpace;
    { Set trackbar position }
    with trackStarThick do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
    LabelStarThick1.Caption := IntToStr(trackStarThick.Position);
  end;
  setStarSpecific;
end;

procedure TForm1.trackStepChange(Sender: TObject);
var
  iPoint: TPoint;
  iOffset, iSpace: Integer;
begin
  if trackStep.MouseInClient then
  begin
    { Get position from mouse cursor position }
    iPoint := Mouse.CursorPos;
    iSpace := 10; { area between left of trackBar and indicator }
    iOffset := iPoint.X - Left - (Width - Clientwidth) div 2 - trackStep.Left - iSpace;
    { Set trackbar position }
    with trackStep do
      Position := Round(Min + iOffset / (Width - 2 * iSpace) * (Max - Min));
  end;
  setBrushCommonParams;
  LabelStep1.Caption := IntToStr(trackStep.Position);
end;

procedure TForm1.Undo1Click(Sender: TObject);
var
  iWidth, iHeight: Integer;
  iAlphaScanline: Pointer;
begin
  PaintView1.Proc.Undo();
  PaintView1.Proc.ClearUndo;
  AUndoMap.Assign(PaintView1.IEBitmap);
  iHeight := PaintView1.IEBitmap.Height;
  iWidth := PaintView1.IEBitmap.Width;
  iAlphaScanline := nil;
  if PaintView1.HasAlphaChannel then
    iAlphaScanline := PaintView1.AlphaChannel.ScanLine[iHeight - 1];
  speSetSurface(PaintView1.IEBitmap.ScanLine[iHeight - 1], iAlphaScanline, iWidth, iHeight, 4);
  speSetShape(AShapeType); // set shape
  pageBrushesChange(self); // set brush stuff
  speSetRender(px_rndDraw); // set render engine
  setColorParams();
  PaintView1.Update;
  Clear1.Enabled := PaintView1.Proc.CanUndo;
  Undo1.Enabled := PaintView1.Proc.CanUndo;
  StatusBar1.Panels[5].Text := 'Undo: ' + IntToStr(PaintView1.Proc.UndoCount);
end;

procedure TForm1.bumpChange(Sender: TObject);
begin
  setBrushCommonParams();
end;


procedure TForm1.cmbColorPrimarySelect(Sender: TObject);
begin
  IEColorPalette1.SelectedColor := cmbColorPrimary.Selected;
  setColorParams;
end;

procedure TForm1.cmbColorSecondarySelect(Sender: TObject);
begin
  IEColorPalette2.SelectedColor := cmbColorSecondary.Selected;
  setColorParams;
end;

procedure TForm1.cmbColorShadowChange(Sender: TObject);
begin
  shadowChange(Sender);
end;

procedure TForm1.colorChange(Sender: TObject);
begin
  setColorParams();
end;

procedure TForm1.DisplayCursor1Click(Sender: TObject);
begin
  if DisplayCursor1.Checked then
  begin
    PaintView1.OnDrawBackBuffer := PaintView1DrawBackBuffer;
    PaintView1.Update();
  end
  else
  begin
    PaintView1.OnDrawBackBuffer := nil;
    PaintView1.Update();
  end;
end;

procedure TForm1.DisplayCursor1MouseEnter(Sender: TObject);
begin
  PaintView1.OnDrawBackBuffer := PaintView1DrawBackBuffer;
  PaintView1.Update();
end;

procedure TForm1.DisplayCursor1MouseLeave(Sender: TObject);
begin
  PaintView1.OnDrawBackBuffer := nil;
  PaintView1.Update();
end;

procedure TForm1.Exit2Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.jitterChange(Sender: TObject);
begin
  setBrushCommonParams();
end;

procedure TForm1.shadowChange(Sender: TObject);
var
  iShadowColor: Cardinal;
begin
  //
  shpBack.Left := shpFor.Left + trackShadowX.Position;
  shpBack.Top := shpFor.Top + trackShadowY.Position;
  shpBack.Brush.Color := cmbColorShadow.Selected;
  ARenderData.RenderParams.DoShadow := chkShadowOn.Checked;
  ARenderData.ShadowParams.MainMode := 1; // currently only mode available
  ARenderData.ShadowParams.Xoffset := trackShadowX.Position;
  ARenderData.ShadowParams.Yoffset := trackShadowY.Position;
  ARenderData.ShadowParams.BlurOn := chkShadowBlur.Checked;
  ARenderData.ShadowParams.BlurValue := trackShadowBlur.Position;
  ARenderData.ShadowParams.Capacity := trackShadowCapacity.Position;
  speSetRenderData(ARenderData);
  iShadowColor := Cardinal(cmbColorShadow.Selected);
  speSetShadowColor(iShadowColor);
end;

procedure TForm1.listColorSchemeClick(Sender: TObject);
begin
  case listColorScheme.ItemIndex of
    0:
      AColorScheme := px_CTYPE_PRIMARY;
    1:
      AColorScheme := px_CTYPE_SECONDARY;
    2:
      AColorScheme := px_CTYPE_MIXED;
    3:
      AColorScheme := px_CTYPE_SOLIDMIXED;
    4:
      AColorScheme := px_CTYPE_PALETTE;
    5:
      AColorScheme := px_CTYPE_SOLIDPALETTE;
    6:
      AColorScheme := px_CTYPE_TEXTUREALIGNED;
    7:
      AColorScheme := px_CTYPE_TEXTUREFIXED;
    8:
      AColorScheme := px_CTYPE_CLONEALIGNED;
    9:
      AColorScheme := px_CTYPE_CLONEREPOS;
    10:
      AColorScheme := px_CTYPE_CLONEFIXED;
    11:
      AColorScheme := px_CTYPE_PALETTE_STEP_C;
    12:
      AColorScheme := px_CTYPE_PALETTE_STEP_FB;
    13:
      AColorScheme := px_CTYPE_PALETTE_STEP_STOP;
    14:
      AColorScheme := px_CTYPE_MOUSE_DOWN;
    15:
      AColorScheme := px_CTYPE_IMAGE_STEP;
    16:
      AColorScheme := px_CTYPE_ABSQUE;
    18:
      AColorScheme := px_CTYPE_GRADIENT_STEP_C;
    19:
      AColorScheme := px_CTYPE_GRADIENT_STEP_FB;
    20:
      AColorScheme := px_CTYPE_GRADIENT_STEP_STOP;
  else
    AColorScheme := px_CTYPE_PRIMARY;
  end;
  speSetColorScheme(AColorScheme);
end;

procedure TForm1.filtersChange(Sender: TObject);
begin
  setBrushCommonParams();
end;

procedure TForm1.Fit1Click(Sender: TObject);
begin
  if Fit1.Checked then
    PaintView1.Fit()
  else
    PaintView1.Zoom := 100;
  Zoom.Caption := 'Zoom: ' + IntToStr(Round(PaintView1.Zoom)) + '%';
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  iWidth, iHeight: Integer;
  iShadowColor: Cardinal;
  i: Integer;
begin
  IEGlobalSettings().AutoFragmentBitmap := False;
  // IEGlobalSettings().AutoFragmentBitmap := True;
  listColorScheme.ItemIndex := 0;
  AStampName := '';
  ATextureName := '';
  ATileName := '';
  shpBack.Left := shpFor.Left + 4;
  shpBack.Top := shpFor.Top + 4;
  speInit(ARenderData);
  NameVer := 'spEngine.dll ver.' + UnicodeString(speGetVersion) + '  VCL Demo- ';
  Caption := NameVer;
  // PaintView1.IEBitmap.PixelFormat := ie24RGB;  not needed.... this is the default
  PaintView1.IEBitmap.Width := 1600;
  PaintView1.IEBitmap.Height := 1024;
  PaintView1.IEBitmap.Fill(clWhite);
  PaintView1.Proc.AutoUndo := False;
  PaintView1.Proc.UndoLimit := 100;
  PaintView1.SetChessboardStyle(8);
  PaintView1.EnableAlphaChannel := true;
  PaintView1.AlphaChannel.Full := false;
  Undo1.Enabled := PaintView1.Proc.CanUndo;
  iHeight := PaintView1.IEBitmap.Height;
  iWidth := PaintView1.IEBitmap.Width;
  { Create Undo bitmap }
  AUndoMap := TIEBitmap.Create(PaintView1.IEBitmap);
  speAddSurface;
  speSetSurface(PaintView1.IEBitmap.ScanLine[iHeight - 1], nil, iWidth, iHeight, 4);
  // when bitmap is not fragmented this peace of code will do the job
  {
    speSurfaceBegin(w, h);
    for i := 0 to h-1 do
    speSurfaceAddScanline(PaintView.IEBitmap.ScanLine[i], nil);
    speSurfaceFinish;
  }
  AShapeType := px_shpFreeHand;
  speSetShape(AShapeType);
  speSetBrush(px_brshNeon);
  speGetBrushCommon(ABrushCommonParams);
  setBrushCommonParams();
  ANeonSpecific := PTpx_BrushNeonSpecific(speGetBrushSpecific());
  setNeonSpecific();
  speSetRender(px_rndDraw);
  ARenderData.RenderParams.DrawTipOnMouseDown := True;
  speSetRenderData(ARenderData);
  iShadowColor := Cardinal(cmbColorShadow.Selected);
  speSetShadowColor(iShadowColor);
  Undo1.Enabled := PaintView1.Proc.CanUndo;
  IEColorPalette1.HintFormat := IECP_Delphi_Value + #13 + 'R: ' + IECP_RGB_R_Value + ', G: ' + IECP_RGB_G_Value + ', B: ' +
    IECP_RGB_B_Value + #13 + 'C: ' + IECP_CMYK_C_Value + ', M: ' + IECP_CMYK_M_Value + ', Y: ' + IECP_CMYK_Y_Value + ', K: '
    + IECP_CMYK_K_Value + #13 + 'H: ' + IECP_HSL_H_Value + ', S: ' + IECP_HSL_S_Value + ', L: ' + IECP_HSL_L_Value + #13 +
    'H: ' + IECP_HSV_H_Value + ', S: ' + IECP_HSV_S_Value + ', V: ' + IECP_HSV_V_Value;
  IEColorPalette2.HintFormat := IECP_Delphi_Value + #13 + 'R: ' + IECP_RGB_R_Value + ', G: ' + IECP_RGB_G_Value + ', B: ' +
    IECP_RGB_B_Value + #13 + 'C: ' + IECP_CMYK_C_Value + ', M: ' + IECP_CMYK_M_Value + ', Y: ' + IECP_CMYK_Y_Value + ', K: '
    + IECP_CMYK_K_Value + #13 + 'H: ' + IECP_HSL_H_Value + ', S: ' + IECP_HSL_S_Value + ', L: ' + IECP_HSL_L_Value + #13 +
    'H: ' + IECP_HSV_H_Value + ', S: ' + IECP_HSV_S_Value + ', V: ' + IECP_HSV_V_Value;
  for i := 0 to cmbColorPrimary.Items.Count - 1 do
  begin
    IEColorPalette1.AddColor(cmbColorPrimary.Colors[i]);
    IEColorPalette2.AddColor(cmbColorSecondary.Colors[i]);
  end;
  // set default colors
  cmbColorPrimary.Selected := clPurple;
  cmbColorSecondary.Selected := clYellow;
  cmbColorPoly.Selected := clGreen;
  cmbColorShadow.Selected := clBlack;
  setColorParams();
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  { Free Undo bitmap }
  AUndoMap.Free;
end;

procedure TForm1.IEColorPalette1SelectedColorChange(Sender: TObject);
begin
  cmbColorPrimary.Selected := IEColorPalette1.SelectedColor;
  setColorParams;
end;

procedure TForm1.IEColorPalette2SelectedColorChange(Sender: TObject);
begin
  cmbColorSecondary.Selected := IEColorPalette2.SelectedColor;
  setColorParams;
end;

procedure TForm1.pageBrushesChange(Sender: TObject);
{
var
  iVisible: Boolean;
  }
begin
  case (pageBrushes.ActivePageIndex) of
    0:
      begin
        speSetBrush(px_brshNeon);
        ANeonSpecific := PTpx_BrushNeonSpecific(speGetBrushSpecific());
        setNeonSpecific();
      end;
    1:
      begin
        speSetBrush(px_brshSolid);
        ASolidSpecific := PTpx_BrushSolidSpecific(speGetBrushSpecific());
        setSolidSpecific();
      end;
    2:
      begin
        speSetBrush(px_brshSpray);
        ASpraySpecific := PTpx_BrushSpraySpecific(speGetBrushSpecific());
        setSpraySpecific();
      end;
    3:
      begin
        speSetBrush(px_brshStar);
        AStarSpecific := PTpx_BrushStarSpecific(speGetBrushSpecific());
        setStarSpecific();
      end;
    4:
      begin
        speSetBrush(px_brshHair);
        AHairSpecific := PTpx_BrushHairSpecific(speGetBrushSpecific());
        setHairSpecific();
      end;
    5:
      begin
        speSetBrush(px_brshMesh);
        AMeshSpecific := PTpx_BrushMeshSpecific(speGetBrushSpecific());
        setMeshSpecific();
      end;
    6:
      begin
        speSetBrush(px_brshParallel);
        AParallelSpecific := PTpx_BrushParallelSpecific(speGetBrushSpecific());
        setParallelSpecific();
      end;
    7:
      begin
        speSetBrush(px_brshStamp);
        setStampSpecific();
      end;
    8:
      speSetBrush(px_brshCml);
  end;
  setBrushCommonParams();
  setColorParams();
  speSetColorScheme(AColorScheme);
end;

procedure TForm1.pageCommonChange(Sender: TObject);
begin
  if pageCommon.ActivePageIndex = 3 then
  begin
    if IEColorPalette1.ColorCount > 0 then
      IEColorPalette1.SelectedColor := cmbColorPrimary.Selected;
    if IEColorPalette2.ColorCount > 0 then
      IEColorPalette2.SelectedColor := cmbColorSecondary.Selected;
  end;
end;

procedure TForm1.PaintView1DrawBackBuffer(Sender: TObject);
{ Draw the backbuffer. }
var
  i: Double;
  x1, y1, x2, y2: Integer;
  iz: Double;
  iBX: Integer;
  iBY: Integer;
begin
  iBX := PaintView1.XScr2Bmp(ABX);
  iBY := PaintView1.YScr2Bmp(ABY);
  if (iBX >= 0) and (iBX <= PaintView1.IEBitmap.Width - 1) and (iBY >= 0) and (iBY <= PaintView1.IEBitmap.Height - 1) then
  begin
    with PaintView1.BackBuffer.Canvas do
    begin
      i := trackSize.Position;
      Pen.Mode := pmNotXor;
      Pen.Color := clBlack;
      Brush.Style := bsClear;
      iz := PaintView1.Zoom / 100;
      x1 := Round(ABX - i / 2 * iz);
      y1 := Round(ABY - i / 2 * iz);
      x2 := Round(ABX + i / 2 * iz);
      y2 := Round(ABY + i / 2 * iz);
      if (rgpSolid.ItemIndex = 0) or (rgpSolid.ItemIndex = 2) then
        Ellipse(x1, y1, x2, y2)
      else
        Rectangle(x1, y1, x2, y2);
    end;
  end;
end;

procedure TForm1.PaintView1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  w,h: Integer;
  pos: TPoint;
begin
  if (Button <> mbLeft) then
    exit;
  if (ssCtrl in Shift) then
   begin
   h := PaintView1.IEBitmap.Height;
   w := PaintView1.IEBitmap.Width;
   speCloneSelf(px_cltBuffered);
   //speSetColorScheme(px_CTYPE_CLONEREPOS);
   BalloonHint1.Title := 'Clone position picked';
   BalloonHint1.Description := 'X = ' + IntToStr(X) + ', Y = '+IntToStr(Y);
   pos.X := X;
   pos.Y := Y;
   speSetClonePosition(PaintView1.CurrentLayer.ConvXScr2Bmp(X),
                       PaintView1.CurrentLayer.ConvYScr2Bmp(Y));
   BalloonHint1.ShowHint(PaintView1.ClientToScreen(pos));
   exit;
   end;
  AMouseDown := True;
  X := PaintView1.CurrentLayer.ConvXScr2Bmp(X);
  Y := PaintView1.CurrentLayer.ConvYScr2Bmp(Y);
  PaintView1.Proc.SaveUndo();
  Clear1.Enabled := PaintView1.Proc.CanUndo;
  Undo1.Enabled := PaintView1.Proc.CanUndo;
  StatusBar1.Panels[5].Text := 'Undo: ' + IntToStr(PaintView1.Proc.UndoCount);
  if AShapeType = px_shpFreeHand then
  begin
    speHandMouseDown(Shift, X, Y);
    if ARenderData.RenderParams.DrawTipOnMouseDown then
      PaintView1.Update();
  end
  else
  begin
    speObjectMouseDown(Shift, X, Y);
    Ahobj := PaintView1.AddNewObject();
    PaintView1.ObjLayer[Ahobj] := PaintView1.LayersCurrent;
    if (AShapeType = px_shpEllipse) or (AShapeType = px_shpEllipseFilled) or (AShapeType = px_shpEllipseFilledNB) then
      PaintView1.ObjKind[Ahobj] := iekELLIPSE
    else if (AShapeType = px_shpRectangle) or (AShapeType = px_shpRectangleFilled) or (AShapeType = px_shpRectangleFilledNB)
    then
      PaintView1.ObjKind[Ahobj] := iekBox
    else
      PaintView1.ObjKind[Ahobj] := iekLINE;
    PaintView1.ObjLeft[Ahobj] := X;
    PaintView1.ObjTop[Ahobj] := Y;
    PaintView1.ObjWidth[Ahobj] := 0;
    PaintView1.ObjHeight[Ahobj] := 0;
    //
    PaintView1.ObjBrushStyle[Ahobj] := bsClear;
    PaintView1.ObjPenColor[Ahobj] := clRed;
    PaintView1.ObjPenWidth[Ahobj] := trackSize.Position;
    PaintView1.ObjStyle[Ahobj] := [ievsVisible];
  end;
end;

procedure TForm1.PaintView1MouseEnter(Sender: TObject);
begin
  PaintView1.OnDrawBackBuffer := PaintView1DrawBackBuffer;
  PaintView1.Update;
  if PaintView1.HasAlphaChannel then
    StatusBar1.Panels[6].Text := 'AlphaChannel: Yes'
  else
    StatusBar1.Panels[6].Text := 'AlphaChannel: No';
end;

procedure TForm1.PaintView1MouseLeave(Sender: TObject);
begin
  PaintView1.OnDrawBackBuffer := nil;
  PaintView1.Update(); // Remove the cursor drawing
  if PaintView1.HasAlphaChannel then
    StatusBar1.Panels[6].Text := 'AlphaChannel: Yes'
  else
    StatusBar1.Panels[6].Text := 'AlphaChannel: No';
end;

procedure TForm1.PaintView1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
  iRect: TRect;
  iAlpha: integer;
  iOpacity: integer;
begin
  if DisplayCursor1.Checked then
  begin
    ABX := X; // Values used in OnDrawBackBuffer event
    ABY := Y;
    PaintView1.Update(); // Execute the OnDrawBackBuffer event to draw the cursor
  end
  else
  begin
    PaintView1.OnDrawBackBuffer := nil;
    PaintView1.Update(); // Remove the cursor drawing
  end;
  X := PaintView1.CurrentLayer.ConvXScr2Bmp(X);
  Y := PaintView1.CurrentLayer.ConvYScr2Bmp(Y);
  if (X >= 0) and (X <= PaintView1.IEBitmap.Width - 1) and (Y >= 0) and (Y <= PaintView1.IEBitmap.Height - 1) then
  begin
    PaintView1.OnDrawBackBuffer := PaintView1DrawBackBuffer;
    PaintView1.Update;
    { Display X, Y position }
    StatusBar1.Panels[2].Text := 'Column: ' + IntegerToString(X + 1);
    StatusBar1.Panels[3].Text := 'Row: ' + IntegerToString(Y + 1);
    { Display Alpha and Opacity }
    iAlpha := PaintView1.IEBitmap.Alpha[X, Y];
    iOpacity := IEAlphaToOpacity(iAlpha);
    StatusBar1.Panels[4].Text := 'Opacity: ' + IntToStr(iOpacity) + '%';
  end;

  if PaintView1.HasAlphaChannel then
    StatusBar1.Panels[6].Text := 'AlphaChannel: Yes'
  else
    StatusBar1.Panels[6].Text := 'AlphaChannel: No';

  if not AMouseDown then
    exit;

  if AShapeType = px_shpFreeHand then
  begin
    speHandMouseMove(Shift, X, Y);
    PaintView1.Update();
  end
  else if AShapeType = px_shpLine then
  begin
    speObjectMouseMove(Shift, X, Y);
    speGetMouseData(AMouseData);
    PaintView1.ObjWidth[Ahobj] := X - AMouseData.X_down;
    PaintView1.ObjHeight[Ahobj] := Y - AMouseData.Y_down;
  end
  else
  begin
    speObjectMouseMove(Shift, X, Y);
    speGetMouseData(AMouseData);
    iRect.Left := AMouseData.X_down;
    iRect.Top := AMouseData.Y_down;
    iRect.right := AMouseData.X_move_to;
    iRect.bottom := AMouseData.Y_move_to;
    iRect.NormalizeRect;
    PaintView1.ObjLeft[Ahobj] := iRect.Left;
    PaintView1.ObjTop[Ahobj] := iRect.Top;
    PaintView1.ObjWidth[Ahobj] := iRect.Width;
    PaintView1.ObjHeight[Ahobj] := iRect.Height;
  end;
end;

procedure TForm1.PaintView1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  AMouseDown := False;
  PaintView1.RemoveAllObjects;
  X := PaintView1.CurrentLayer.ConvXScr2Bmp(X);
  Y := PaintView1.CurrentLayer.ConvYScr2Bmp(Y);
  if AShapeType = px_shpFreeHand then
    speHandMouseUp(Shift, X, Y)
  else
    speObjectMouseUp(Shift, X, Y);
end;

procedure TForm1.PaintView1ViewChange(Sender: TObject; Change: Integer);
begin
  TrackZoom.Position := Round(PaintView1.Zoom);
  Zoom.Caption := 'Zoom: ' + IntToStr(Round(PaintView1.Zoom)) + '%';
end;

procedure TForm1.rgpSolidClick(Sender: TObject);
begin
  setSolidSpecific();
end;

procedure TForm1.chkSolidFilledClick(Sender: TObject);
begin
labSolidThick.Visible := chkSolidFilled.Checked;
LabelSolidThick1.Visible := chkSolidFilled.Checked;
trackSolidThick.Visible := chkSolidFilled.Checked;
setSolidSpecific();
end;

end.
