unit frmMainU;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, hyieutils, iexBitmaps, hyiedefs,
  iesettings, Vcl.Menus, Vcl.ComCtrls, Vcl.ExtCtrls, ieview, imageenview, ievect,
  cxGraphics, cxControls, cxLookAndFeels, cxLookAndFeelPainters, cxContainer,
  cxEdit, Vcl.StdCtrls, cxTrackBar, spenginedll, spglobals, dxSkinsCore,
  dxSkinDarkRoom, dxSkinDarkSide, ieopensavedlg, cxTextEdit, cxMaskEdit,
  cxSpinEdit, cxDropDownEdit, cxColorComboBox, iexRulers, System.Contnrs;

type
  TfrmMain = class(TForm)
    PaintView: TImageEnVect;
    panRight: TPanel;
    statusBar: TStatusBar;
    panLeft: TPanel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    menuLoadImage: TMenuItem;
    menuSaveImage: TMenuItem;
    pageCommon: TPageControl;
    TabSheet1: TTabSheet;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    trackSize: TcxTrackBar;
    trackCapacity: TcxTrackBar;
    trackColorVary: TcxTrackBar;
    trackSizeVary: TcxTrackBar;
    trackCapVary: TcxTrackBar;
    trackStep: TcxTrackBar;
    TabSheet2: TTabSheet;
    GroupBox3: TGroupBox;
    chkFiltersChalk: TCheckBox;
    chkFiltersBlur: TCheckBox;
    trackBlurRadius: TcxTrackBar;
    pageBrushes: TPageControl;
    TabSheet3: TTabSheet;
    GroupBox2: TGroupBox;
    trackNeonLinear: TcxTrackBar;
    rbtNeonLinear: TRadioButton;
    rbtNeonQuadratic: TRadioButton;
    rbtNeonTrigonometric: TRadioButton;
    trackNeonTrigonometric: TcxTrackBar;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    TabSheet7: TTabSheet;
    TabSheet8: TTabSheet;
    rgpSolid: TRadioGroup;
    labSolidThick: TLabel;
    trackSolidThick: TcxTrackBar;
    TabSheet9: TTabSheet;
    TabSheet10: TTabSheet;
    TabSheet11: TTabSheet;
    Label7: TLabel;
    trackSprayThick: TcxTrackBar;
    Label8: TLabel;
    trackSprayIntVary: TcxTrackBar;
    Label9: TLabel;
    trackSprayGravity: TcxTrackBar;
    Label10: TLabel;
    trackSprayDensity: TcxTrackBar;
    Label11: TLabel;
    trackStarThick: TcxTrackBar;
    Label12: TLabel;
    trackStarIntVary: TcxTrackBar;
    Label13: TLabel;
    trackStarDensity: TcxTrackBar;
    Label14: TLabel;
    trackHairThick: TcxTrackBar;
    Label15: TLabel;
    trackHairIntVary: TcxTrackBar;
    Label16: TLabel;
    trackHairDensity: TcxTrackBar;
    Label17: TLabel;
    trackMeshThick: TcxTrackBar;
    Label18: TLabel;
    trackMeshIntVary: TcxTrackBar;
    Label19: TLabel;
    trackMeshDensity: TcxTrackBar;
    Label20: TLabel;
    trackParallelThick: TcxTrackBar;
    Label21: TLabel;
    trackParallelIntVary: TcxTrackBar;
    Label22: TLabel;
    trackParallelSpacing: TcxTrackBar;
    Label23: TLabel;
    trackParallelAngle: TcxTrackBar;
    StampView: TImageEnView;
    labStampBrush: TLabel;
    OpenImage: TOpenImageEnDialog;
    OpenStamp: TOpenImageEnDialog;
    GroupBox4: TGroupBox;
    chkBumpEnable: TCheckBox;
    chkBumpSoft: TCheckBox;
    Label25: TLabel;
    trackBumpScale: TcxTrackBar;
    Label26: TLabel;
    trackBumpThreshold: TcxTrackBar;
    chkBumpInvertThreshold: TCheckBox;
    Label27: TLabel;
    trackBumpRoughness: TcxTrackBar;
    editBumpY: TcxSpinEdit;
    Label28: TLabel;
    Label29: TLabel;
    editBumpX: TcxSpinEdit;
    popShape: TPopupMenu;
    shFree: TMenuItem;
    N1: TMenuItem;
    shLine: TMenuItem;
    N2: TMenuItem;
    shRectOut: TMenuItem;
    shRectFilled: TMenuItem;
    shRectFilled0: TMenuItem;
    N3: TMenuItem;
    shEllipseOut: TMenuItem;
    shEllipseFilled: TMenuItem;
    shEllipseFilled0: TMenuItem;
    TabSheet12: TTabSheet;
    GroupBox5: TGroupBox;
    chkJitterOn: TCheckBox;
    chkJitterConnected: TCheckBox;
    Label30: TLabel;
    trackJitterRange: TcxTrackBar;
    Label31: TLabel;
    trackJitterLoop: TcxTrackBar;
    TabSheet13: TTabSheet;
    GroupBox6: TGroupBox;
    Label32: TLabel;
    cmbColorPrimary: TcxColorComboBox;
    Label33: TLabel;
    cmbColorSecondary: TcxColorComboBox;
    Label34: TLabel;
    TextureView: TImageEnView;
    Label35: TLabel;
    TileView: TImageEnView;
    Label36: TLabel;
    trackColorStepper: TcxTrackBar;
    chkColorAutoStepper: TCheckBox;
    OpenTexture: TOpenImageEnDialog;
    OpenTile: TOpenImageEnDialog;
    Label37: TLabel;
    listColorScheme: TListBox;
    btnTextureClear: TButton;
    btnTileClear: TButton;
    GroupBox7: TGroupBox;
    cmbColorPoly: TcxColorComboBox;
    PolyTextureView: TImageEnView;
    btnPolyTextureClear: TButton;
    rbtPolyColor: TRadioButton;
    rbtPolyTexture: TRadioButton;
    chkPolyFillOver: TCheckBox;
    TabSheet14: TTabSheet;
    chkPolyCapacity: TCheckBox;
    trackPolyCapacity: TcxTrackBar;
    chkShadowBlur: TCheckBox;
    trackShadowBlur: TcxTrackBar;
    trackShadowX: TcxTrackBar;
    Label24: TLabel;
    Label38: TLabel;
    trackShadowY: TcxTrackBar;
    Label39: TLabel;
    trackShadowCapacity: TcxTrackBar;
    cmbColorShadow: TcxColorComboBox;
    Label40: TLabel;
    shpBack: TShape;
    shpFor: TShape;
    chkShadowOn: TCheckBox;
    Label41: TLabel;
    Label42: TLabel;
    SaveImage: TSaveImageEnDialog;
    btnUndo: TButton;
    chkFiltersInvert: TCheckBox;
    trackInvertValue: TcxTrackBar;
    chkFiltersMedian: TCheckBox;
    trackMedianRadius: TcxTrackBar;
    chkSolidFilled: TCheckBox;
    BalloonHint1: TBalloonHint;
    procedure FormShow(Sender: TObject);
    procedure PaintViewMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintViewMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintViewMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure basicChange(Sender: TObject);
    procedure brushNeonChange(Sender: TObject);
    procedure pageBrushesChange(Sender: TObject);
    procedure filtersChange(Sender: TObject);
    procedure rgpSolidClick(Sender: TObject);
    procedure trackSolidChange(Sender: TObject);
    procedure trackSprayChange(Sender: TObject);
    procedure trackStarChange(Sender: TObject);
    procedure trackHairChange(Sender: TObject);
    procedure trackMeshChange(Sender: TObject);
    procedure trackParallelChange(Sender: TObject);
    procedure StampViewDblClick(Sender: TObject);
    procedure bumpChange(Sender: TObject);
    procedure popShapeClick(Sender: TObject);
    procedure jitterChange(Sender: TObject);
    procedure colorChange(Sender: TObject);
    procedure TextureViewDblClick(Sender: TObject);
    procedure TileViewDblClick(Sender: TObject);
    procedure listColorSchemeClick(Sender: TObject);
    procedure btnTextureClearClick(Sender: TObject);
    procedure btnTileClearClick(Sender: TObject);
    procedure menuLoadImageClick(Sender: TObject);
    procedure PolyTextureViewDblClick(Sender: TObject);
    procedure btnPolyTextureClearClick(Sender: TObject);
    procedure polyChanged(Sender: TObject);
    procedure shadowChange(Sender: TObject);
    procedure menuSaveImageClick(Sender: TObject);
    procedure btnUndoClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure chkSolidFilledClick(Sender: TObject);
  private
    { Private declarations }
    procedure setBrushCommonParams();
    procedure setColorParams();
    procedure setNeonSpecific();
    procedure setSolidSpecific();
    procedure setSpraySpecific();
    procedure setStarSpecific();
    procedure setHairSpecific();
    procedure setMeshSpecific();
    procedure setParallelSpecific();
    procedure setStampSpecific();
    procedure loadTexture(filename: UnicodeString);
    procedure loadTile(filename: UnicodeString);
    procedure loadPolyTexture(filename: Unicodestring);
    procedure loadStamp(filename: UnicodeString);
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;
  renderData: Tpx_RenderData;
  brushCommonParams: Tpx_BrushCommonParams;
  neonSpecific: PTpx_BrushNeonSpecific;
  solidSpecific: PTpx_BrushSolidSpecific;
  spraySpecific:  PTpx_BrushSpraySpecific;
  starSpecific:  PTpx_BrushStarSpecific;
  hairSpecific:  PTpx_BrushHairSpecific;
  meshSpecific:  PTpx_BrushMeshSpecific;
  parallelSpecific: PTpx_BrushParallelSpecific;
  ColorScheme: Integer;
  StampName, TextureName, TileName, PolyTextureName: UnicodeString;
  ShapeType: TspeShapeType;
  MouseData: Tpx_MouseData;
  _mouseDown: Boolean;
  _hobj: Integer;
  _undoMap: TIEBitmap;
implementation

{$R *.dfm}

//---------------------------------------------------------------------------
// private
procedure TfrmMain.setBrushCommonParams();
begin
brushCommonParams.Size := trackSize.Position;
brushCommonParams.Capacity := trackCapacity.Position;
brushCommonParams.ColorVary := trackColorVary.Position;
brushCommonParams.SizeVary := trackSizeVary.Position;
brushCommonParams.CapVary := trackCapVary.Position;
brushCommonParams.Step := trackStep.Position;
// filters
brushCommonParams.ChalkOn := chkFiltersChalk.Checked;
brushCommonParams.BlurOn := chkFiltersBlur.Checked;
brushCommonParams.BlurValue := trackBlurRadius.Position;
brushCommonParams.InvertOn := chkFiltersInvert.Checked;
brushCommonParams.InvertValue := trackInvertValue.Position;
brushCommonParams.MedianOn := chkFiltersMedian.Checked;
brushCommonParams.MedianValue := trackMedianRadius.Position;
// bumping
brushCommonParams.BumpOn := chkBumpEnable.Checked;
brushCommonParams.BumpSoft := chkBumpSoft.Checked;
brushCommonParams.BumpScaleValue := trackBumpScale.Position * 1.0 / 100.0;
brushCommonParams.BumpThresholdValue := trackBumpThreshold.Position;
brushCommonParams.BumpInvertThreshold := chkBumpInvertThreshold.Checked;
brushCommonParams.BumpRoughnessValue := trackBumpRoughness.Position;
brushCommonParams.BumpXoffsetValue := editBumpX.Value;
brushCommonParams.BumpYoffsetValue := editBumpY.Value;
// jitter
brushCommonParams.JitterOn := chkJitterOn.Checked;
brushCommonParams.JitterConnectedOn := chkJitterConnected.Checked;
brushCommonParams.JitterRangeValue := trackJitterRange.Position;
brushCommonParams.JitterLoopValue := trackJitterLoop.Position;
// poly (closed shapes filling)
brushCommonParams.PolyFillOver := chkPolyFillOver.Checked;
brushCommonParams.PolyColorIndex := Integer(rbtPolyTexture.Checked) * 1;
speSetBrushCommon(brushCommonParams);
end;
//---------------------------------------------------------------------------
procedure TfrmMain.setColorParams();
var
 c1, c2, c3: Cardinal;
begin
// colors
c1 := Cardinal(cmbColorPrimary.ColorValue);
c2 := Cardinal(cmbColorSecondary.ColorValue);
c3 := Cardinal(cmbColorPoly.ColorValue);
speSetStandardColors(c1, c2, c3);
if not TextureName.IsEmpty then
   loadTexture(TextureName);
if not TileName.IsEmpty then
   loadTile(TileName);
if not PolyTextureName.IsEmpty then
   loadPolyTexture(PolyTextureName);
end;
//---------------------------------------------------------------------------
procedure TfrmMain.setNeonSpecific();
begin
  neonSpecific.FalloffIndex := Integer(rbtNeonQuadratic.Checked) * 1 + Integer(rbtNeonTrigonometric.Checked) * 2;
  neonSpecific.LinearValue := trackNeonLinear.Position;
  neonSpecific.TrigonometricValue := trackNeonTrigonometric.Position;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.setSolidSpecific();
begin
  solidSpecific.Shape := rgpSolid.ItemIndex;
  solidSpecific.Filled := chkSolidFilled.Checked;
  solidSpecific.Thickness := trackSolidThick.Position;
  //solidSpecific.Angle := 0;
  solidSpecific.RandomAngle := True;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.setSpraySpecific();
begin
  spraySpecific.Thickness := trackSprayThick.Position;
  spraySpecific.IntVary   := trackSprayIntVary.Position;
  spraySpecific.Gravity   := trackSprayGravity.Position;
  spraySpecific.Density   := trackSprayDensity.Position;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.setStarSpecific();
begin
  starSpecific.Thickness := trackStarThick.Position;
  starSpecific.IntVary   := trackStarIntVary.Position;
  starSpecific.Density   := trackStarDensity.Position;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.setHairSpecific();
begin
  hairSpecific.Thickness := trackHairThick.Position;
  hairSpecific.IntVary   := trackHairIntVary.Position;
  hairSpecific.Density   := trackHairDensity.Position;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.setMeshSpecific();
begin
  meshSpecific.Thickness := trackMeshThick.Position;
  meshSpecific.IntVary   := trackMeshIntVary.Position;
  meshSpecific.Density   := trackMeshDensity.Position;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.setParallelSpecific();
begin
  parallelSpecific.Thickness := trackParallelThick.Position;
  parallelSpecific.IntVary   := trackParallelIntVary.Position;
  parallelSpecific.Spacing   := trackParallelSpacing.Position;
  parallelSpecific.Angle     := trackParallelAngle.Position;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.setStampSpecific();
begin
if not StampName.IsEmpty then
   loadStamp(StampName);
end;
//---------------------------------------------------------------------------
procedure TfrmMain.loadTexture(filename: UnicodeString);
var
 ieMap: TIEBitmap;
 w, h: Integer;
begin
   TextureView.IO.LoadFromFile(filename);
   ieMap := TextureView.IEBitmap;
   if (ieMap.PixelFormat <> ie24RGB) then
      begin
  	  TextureView.Proc.ConvertTo24Bit();
	    ieMap := TextureView.IEBitmap;
      end;
   w := ieMap.Width;
   h := ieMap.Height;
   speSetTexture(ieMap.ScanLine[h -1 ], w, h, 4);
end;
//---------------------------------------------------------------------------
procedure TfrmMain.loadPolyTexture(filename: UnicodeString);
var
 ieMap: TIEBitmap;
 w, h: Integer;
begin
   PolyTextureView.IO.LoadFromFile(filename);
   ieMap := PolyTextureView.IEBitmap;
   if (ieMap.PixelFormat <> ie24RGB) then
      begin
  	  TextureView.Proc.ConvertTo24Bit();
	    ieMap := PolyTextureView.IEBitmap;
      end;
   w := ieMap.Width;
   h := ieMap.Height;
   speSetPolyTexture(ieMap.ScanLine[h -1 ], w, h, 4);
end;
//---------------------------------------------------------------------------
procedure TfrmMain.loadTile(filename: UnicodeString);
var
 ieMap: TIEBitmap;
 w, h: Integer;
begin
   TileView.IO.LoadFromFile(filename);
   ieMap := TileView.IEBitmap;
   if (ieMap.PixelFormat <> ie8g) then
      begin
  	  TileView.Proc.ConvertToGray();
  	  TileView.IEBitmap.PixelFormat := ie8g;
	    ieMap := TileView.IEBitmap;
      end;
   w := ieMap.Width;
   h := ieMap.Height;
   speSetBackgroundTile(ieMap.ScanLine[h -1 ], w, h, 4);
end;
//---------------------------------------------------------------------------
procedure TfrmMain.menuLoadImageClick(Sender: TObject);
var
  h, w: Integer;
  alphaScanline: Pointer;
begin
if OpenImage.Execute then
   begin
   PaintView.IO.LoadFromFile(OpenImage.FileName);
   if PaintView.IEBitmap.PixelFormat <> ie24RGB then
   	  PaintView.Proc.ConvertTo24Bit();
   h := PaintView.IEBitmap.Height;
   w := PaintView.IEBitmap.Width;
   _undoMap.Free;
   _undoMap := TIEBitmap.Create(PaintView.IEBitmap);
   alphaScanline := nil;
   if PaintView.HasAlphaChannel then
      alphaScanline := PaintView.AlphaChannel.ScanLine[h - 1];
   speSetSurface(PaintView.IEBitmap.ScanLine[h - 1], alphaScanline, w, h, 4);
   //not needed any more - speSetSurface 0.4 will use previously set shape, brush, etc..
   //speSetShape(ShapeType);   // set shape
   //pageBrushesChange(self);  // set brush stuff
   //speSetRender(px_rndDraw); // set render engine
   setColorParams();
   PaintView.Update;
   end;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.menuSaveImageClick(Sender: TObject);
begin
if SaveImage.Execute then
   begin
   PaintView.IO.SaveToFile(SaveImage.FileName);
   end;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.loadStamp(filename: UnicodeString);
var
 ieMap, aMap: TIEBitmap;
 w, h: Integer;
begin
   StampView.IO.LoadFromFile(OpenStamp.FileName);
   ieMap := StampView.IEBitmap;
   if (ieMap.HasAlphaChannel) then // take alpha channel instead of image
	    begin
	    aMap := ieMap.AlphaChannel;
  	  ieMap := aMap;
      end
   else if (ieMap.PixelFormat <> ie8g) then
      begin
  	  StampView.Proc.ConvertToGray();
  	  StampView.IEBitmap.PixelFormat := ie8g;
	    ieMap := StampView.IEBitmap;
      end;
   w := ieMap.Width;
   h := ieMap.Height;
   if (speSetStamp(ieMap.ScanLine[h -1 ], w, h, 4)) then
      labStampBrush.Caption := 'Original stamp size: ' + IntToStr(w) + ' x ' + IntToStr(h)
   else
      labStampBrush.Caption := 'Stamp brush empty!';
end;
//---------------------------------------------------------------------------
procedure TfrmMain.popShapeClick(Sender: TObject);
var
  temp_item: TMenuItem;
  filled, border: Boolean;
begin
  filled := False;
  border := False;
  temp_item := TMenuItem(Sender);
  temp_item.Checked := True;
  case temp_item.Tag of
     0: ShapeType := px_shpFreeHand;
     1: ShapeType := px_shpLine;
     2: ShapeType := px_shpRectangle;
     3: ShapeType := px_shpRectangleFilled;
     4: ShapeType := px_shpRectangleFilledNB;
     5: ShapeType := px_shpEllipse;
     6: ShapeType := px_shpEllipseFilled;
     7: ShapeType := px_shpEllipseFilledNB;
  end;
speSetShape(ShapeType);
end;
//---------------------------------------------------------------------------
procedure TfrmMain.StampViewDblClick(Sender: TObject);
begin
OpenStamp.InitialDir := ExtractFilePath(Application.ExeName) + 'bstamps';
if (OpenStamp.Execute()) then
   begin
   loadStamp(OpenStamp.FileName);
   StampName := OpenStamp.FileName;
   end;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.TextureViewDblClick(Sender: TObject);
begin
OpenTexture.InitialDir := ExtractFilePath(Application.ExeName) + 'textures';
if (OpenTexture.Execute()) then
   begin
   loadTexture(OpenTexture.FileName);
   TextureName := OpenTexture.FileName;
   end;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.TileViewDblClick(Sender: TObject);
begin
OpenTile.InitialDir := ExtractFilePath(Application.ExeName) + 'tiles';
if (OpenTile.Execute()) then
   begin
   loadTile(OpenTile.FileName);
   TileName := OpenTile.FileName;
   end;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.polyChanged(Sender: TObject);
begin
setBrushCommonParams();
end;
//---------------------------------------------------------------------------
procedure TfrmMain.PolyTextureViewDblClick(Sender: TObject);
begin
if (OpenTexture.Execute()) then
   begin
   loadPolyTexture(OpenTexture.FileName);
   PolyTextureName := OpenTexture.FileName;
   end;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.basicChange(Sender: TObject);
begin
setBrushCommonParams();
end;
//---------------------------------------------------------------------------
procedure TfrmMain.trackHairChange(Sender: TObject);
begin
setHairSPecific();
end;
//---------------------------------------------------------------------------
procedure TfrmMain.trackMeshChange(Sender: TObject);
begin
setMeshSpecific();
end;
//---------------------------------------------------------------------------
procedure TfrmMain.trackParallelChange(Sender: TObject);
begin
setParallelSpecific();
end;
//---------------------------------------------------------------------------
procedure TfrmMain.trackSolidChange(Sender: TObject);
begin
setSolidSpecific();
end;
//---------------------------------------------------------------------------
procedure TfrmMain.chkSolidFilledClick(Sender: TObject);
begin
labSolidThick.Visible := chkSolidFilled.Checked;
trackSolidThick.Visible := chkSolidFilled.Checked;
setSolidSpecific();
end;
//---------------------------------------------------------------------------
procedure TfrmMain.rgpSolidClick(Sender: TObject);
begin
setSolidSpecific();
end;
//---------------------------------------------------------------------------
procedure TfrmMain.brushNeonChange(Sender: TObject);
begin
setNeonSpecific();
end;
//---------------------------------------------------------------------------
procedure TfrmMain.btnTextureClearClick(Sender: TObject);
begin
TextureView.Clear;
TextureName := '';
speDeleteTexture;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.btnTileClearClick(Sender: TObject);
begin
TileView.Clear;
TileName := '';
speDeleteBackgroundTile;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.btnUndoClick(Sender: TObject);
begin
_undoMap.DrawToTIEBitmap(PaintView.IEBitmap, 0, 0);
speUpdateSurface;
PaintView.Update;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.btnPolyTextureClearClick(Sender: TObject);
begin
PolyTextureView.Clear;
PolyTextureName := '';
speDeletePolyTexture;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.trackSprayChange(Sender: TObject);
begin
setSpraySpecific();
end;
//---------------------------------------------------------------------------
procedure TfrmMain.trackStarChange(Sender: TObject);
begin
setStarSpecific();
end;
//---------------------------------------------------------------------------
procedure TfrmMain.bumpChange(Sender: TObject);
begin
setBrushCommonParams();
end;
//---------------------------------------------------------------------------
procedure TfrmMain.colorChange(Sender: TObject);
begin
setColorParams();
end;
//---------------------------------------------------------------------------
procedure TfrmMain.jitterChange(Sender: TObject);
begin
setBrushCommonParams();
end;
//---------------------------------------------------------------------------
procedure TfrmMain.shadowChange(Sender: TObject);
var
  sc: Cardinal;
begin
//
shpBack.Left := shpFor.Left + trackShadowX.Position;
shpBack.Top  := shpFor.Top  + trackShadowY.Position;
renderData.RenderParams.DoShadow := chkShadowOn.Checked;
renderData.ShadowParams.MainMode := 1; // currently only mode available
renderData.ShadowParams.Xoffset := trackShadowX.Position;
renderData.ShadowParams.Yoffset := trackShadowY.Position;
renderData.ShadowParams.BlurOn  := chkShadowBlur.Checked;
renderData.ShadowParams.BlurValue  := trackShadowBlur.Position;
renderData.ShadowParams.Capacity   := trackShadowCapacity.Position;
speSetRenderData(renderData);
sc := Cardinal(cmbColorShadow.ColorValue);
speSetShadowColor(sc);
end;
//---------------------------------------------------------------------------
procedure TfrmMain.listColorSchemeClick(Sender: TObject);
begin
case listColorScheme.ItemIndex of
    0: ColorScheme := px_CTYPE_PRIMARY;
    1: ColorScheme := px_CTYPE_SECONDARY;
    2: ColorScheme := px_CTYPE_MIXED;
    3: ColorScheme := px_CTYPE_SOLIDMIXED;
    4: ColorScheme := px_CTYPE_PALETTE;
    5: ColorScheme := px_CTYPE_SOLIDPALETTE;
    6: ColorScheme := px_CTYPE_TEXTUREALIGNED;
    7: ColorScheme := px_CTYPE_TEXTUREFIXED;
    8: ColorScheme := px_CTYPE_CLONEALIGNED;
    9: ColorScheme := px_CTYPE_CLONEREPOS;
    10: ColorScheme := px_CTYPE_CLONEFIXED;
    11: ColorScheme := px_CTYPE_PALETTE_STEP_C;
    12: ColorScheme := px_CTYPE_PALETTE_STEP_FB;
    13: ColorScheme := px_CTYPE_PALETTE_STEP_STOP;
    14: ColorScheme := px_CTYPE_MOUSE_DOWN;
    15: ColorScheme := px_CTYPE_IMAGE_STEP;
    16: ColorScheme := px_CTYPE_ABSQUE;
    18: ColorScheme := px_CTYPE_GRADIENT_STEP_C;
    19: ColorScheme := px_CTYPE_GRADIENT_STEP_FB;
    20: ColorScheme := px_CTYPE_GRADIENT_STEP_STOP;
    else
      ColorScheme := px_CTYPE_PRIMARY;
end;
speSetColorScheme(ColorScheme);
end;

//---------------------------------------------------------------------------
procedure TfrmMain.filtersChange(Sender: TObject);
begin
setBrushCommonParams();
end;
//---------------------------------------------------------------------------
procedure TfrmMain.FormShow(Sender: TObject);
var
  h, w: Integer;
  sc: Cardinal;
  i: Integer;
begin
IEGlobalSettings().AutoFragmentBitmap := False;
//IEGlobalSettings().AutoFragmentBitmap := True;
listColorScheme.ItemIndex := 0;
StampName := '';
TextureName := '';
TileName := '';
shpBack.Left := shpFor.Left + 4;
shpBack.Top  := shpFor.Top + 4;
//
speInit(renderData);
frmMain.Caption := frmMain.Caption + ' ver.' + UnicodeString(speGetVersion) + ' demo';
//
PaintView.IEBitmap.PixelFormat := ie24RGB;
PaintView.IEBitmap.Width  := 1600;
PaintView.IEBitmap.Height := 1024;
PaintView.IEBitmap.Fill(clWhite);
h := PaintView.IEBitmap.Height;
w := PaintView.IEBitmap.Width;
_undoMap := TIEBitmap.Create(PaintView.IEBitmap);
speAddSurface;
speSetSurface(PaintView.IEBitmap.ScanLine[h - 1], nil, w, h, 4);
// when bitmap is not fragmented this peace of code will do the job
{
speSurfaceBegin(w, h);
for i := 0 to h-1 do
    speSurfaceAddScanline(PaintView.IEBitmap.ScanLine[i], nil);
speSurfaceFinish;
}
ShapeType := px_shpFreeHand;
speSetShape(ShapeType);
speSetBrush(px_brshNeon);
speGetBrushCommon(brushCommonParams);
setBrushCommonParams();
neonSpecific := PTpx_BrushNeonSpecific(speGetBrushSpecific());
setNeonSpecific();
speSetRender(px_rndDraw);
// set default colors
cmbColorPrimary.ColorValue := clPurple;
cmbColorSecondary.ColorValue := clYellow;
cmbColorPoly.ColorValue := clGreen;
cmbColorShadow.ColorValue := clBlack;
setColorParams();
renderData.RenderParams.DrawTipOnMouseDown := True;
speSetRenderData(renderData);
sc := Cardinal(cmbColorShadow.ColorValue);
speSetShadowColor(sc);
end;
//---------------------------------------------------------------------------
procedure TfrmMain.FormDestroy(Sender: TObject);
begin
_undoMap.Free;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.pageBrushesChange(Sender: TObject);
begin
case (pageBrushes.ActivePageIndex) of
   0:
     begin
		 speSetBrush(px_brshNeon);
     neonSpecific := PTpx_BrushNeonSpecific(speGetBrushSpecific());
		 setNeonSpecific();
     end;
   1:
     begin
		 speSetBrush(px_brshSolid);
     solidSpecific := PTpx_BrushSolidSpecific(speGetBrushSpecific());
		 setSolidSpecific();
     end;
   2:
     begin
		 speSetBrush(px_brshSpray);
     spraySpecific := PTpx_BrushSpraySpecific(speGetBrushSpecific());
		 setSpraySpecific();
     end;
   3:
     begin
		 speSetBrush(px_brshStar);
     starSpecific := PTpx_BrushStarSpecific(speGetBrushSpecific());
		 setStarSpecific();
     end;
   4:
     begin
		 speSetBrush(px_brshHair);
     hairSpecific := PTpx_BrushHairSpecific(speGetBrushSpecific());
		 setHairSpecific();
     end;
   5:
     begin
		 speSetBrush(px_brshMesh);
     meshSpecific := PTpx_BrushMeshSpecific(speGetBrushSpecific());
		 setMeshSpecific();
     end;
   6:
     begin
		 speSetBrush(px_brshParallel);
     parallelSpecific := PTpx_BrushParallelSpecific(speGetBrushSpecific());
		 setParallelSpecific();
     end;
   7:
     begin
		 speSetBrush(px_brshStamp);
     setStampSpecific();
     end;
   8:
		 speSetBrush(px_brshCml);
   end;
setBrushCommonParams();
setColorParams();
speSetColorScheme(ColorScheme);
end;
//---------------------------------------------------------------------------
procedure TfrmMain.PaintViewMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  w,h: Integer;
  pos: TPoint;
begin
if (Button <> mbLeft) then
   exit;
if (ssCtrl in Shift) then
   begin
   h := PaintView.IEBitmap.Height;
   w := PaintView.IEBitmap.Width;
   speCloneSelf(px_cltBuffered);
   //speSetColorScheme(px_CTYPE_CLONEREPOS);
   BalloonHint1.Title := 'Clone position picked';
   BalloonHint1.Description := 'X = ' + IntToStr(X) + ', Y = '+IntToStr(Y);
   pos.X := X;
   pos.Y := Y;
   speSetClonePosition(PaintView.CurrentLayer.ConvXScr2Bmp(X),
                       PaintView.CurrentLayer.ConvYScr2Bmp(Y));
   BalloonHint1.ShowHint(PaintView.ClientToScreen(pos));
   exit;
   end;
_mouseDown := True;
X := PaintView.CurrentLayer.ConvXScr2Bmp(X);
Y := PaintView.CurrentLayer.ConvYScr2Bmp(Y);
if ShapeType = px_shpFreeHand then
   begin
   speHandMouseDown(Shift, X, Y);
   if renderData.RenderParams.DrawTipOnMouseDown then
      PaintView.Update();
   end
else
   begin
   speObjectMouseDown(Shift, X, Y);
   _hobj := PaintView.AddNewObject();
   PaintView.ObjLayer[_hobj] := PaintView.LayersCurrent;
   if (ShapeType = px_shpEllipse) or (ShapeType = px_shpEllipseFilled) or (ShapeType = px_shpEllipseFilledNB)  then
      PaintView.ObjKind[_hobj] := iekELLIPSE
   else if (ShapeType  = px_shpRectangle) or (ShapeType  = px_shpRectangleFilled) or (ShapeType  = px_shpRectangleFilledNB) then
      PaintView.ObjKind[_hobj] := iekBox
   else
      PaintView.ObjKind[_hobj] := iekLINE;
   PaintView.ObjLeft[_hobj] := X;
   PaintView.ObjTop[_hobj] := Y;
   PaintView.ObjWidth[_hobj] := 0;
   PaintView.ObjHeight[_hobj] := 0;
   //
   PaintView.ObjBrushStyle[_hobj] := bsClear;
   PaintView.ObjPenColor[_hobj]   :=  clRed;
   PaintView.ObjPenWidth[_hobj] := trackSize.Position;
   PaintView.ObjStyle[_hobj] := [ievsVisible];
   end;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.PaintViewMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  rect: TRect;
begin
if not _mouseDown then
   exit;
X := PaintView.CurrentLayer.ConvXScr2Bmp(X);
Y := PaintView.CurrentLayer.ConvYScr2Bmp(Y);
if ShapeType = px_shpFreeHand then
   begin
   speHandMouseMove(Shift, X, Y);
   PaintView.Update();
   end
else if ShapeType = px_shpLine then
   begin
   speObjectMouseMove(Shift, X, Y);
   speGetMouseData(MouseData);
   PaintView.ObjWidth[_hobj] := X - MouseData.X_down;
   PaintView.ObjHeight[_hobj] := Y - MouseData.Y_down;
   end
else
   begin
   speObjectMouseMove(Shift, X, Y);
   speGetMouseData(MouseData);
   rect.left := MouseData.X_down;
   rect.top  := MouseData.Y_down;
   rect.right := MouseData.X_move_to;
   rect.bottom := MouseData.Y_move_to;
   rect.NormalizeRect;
   PaintView.ObjLeft[_hobj] := rect.left;
   PaintView.ObjTop[_hobj] := rect.top;
   PaintView.ObjWidth[_hobj] := rect.Width;
   PaintView.ObjHeight[_hobj] := rect.Height;
   end;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.PaintViewMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
_mouseDown := False;
PaintView.RemoveAllObjects;
X := PaintView.CurrentLayer.ConvXScr2Bmp(X);
Y := PaintView.CurrentLayer.ConvYScr2Bmp(Y);
if ShapeType = px_shpFreeHand then
   speHandMouseUp(Shift, X, Y)
else
   speObjectMouseUp(Shift, X, Y);
end;
//---------------------------------------------------------------------------
end.
